/*
// Casey Burkhardt
// CSC 1051-002 - Algorithms and Data Structures I
// 12/16/2007
// HangmanGUI.java
// Manages the overall Java GUI for Hangman
*/

import javax.swing.*;
import java.awt.*;
import java.io.*;

public class HangmanGUI
{

	// Declare several objects outside of main for use with "ButtonEvent" method.
	static JFrame MainWindow = new JFrame ("Hangman - by: Casey Burkhardt");
	static String gameAnswer;
	static Puzzle puzzle = new Puzzle();
   static PicturePanel Panel2 = new PicturePanel();
	static StatusPanel Panel3 = new StatusPanel();
	
	// Declare several objects outside of main for use with "ButtonEvent" method.
	static boolean gameOver = false;
   static final int LOSEVALUE = 6;


   public static void main (String[] args) throws IOException
   {

		// SETUP FRAMES AND PANELS FOR ALL GAME ELEMENTS
		// Setup Main Game Window
      MainWindow.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);

		// Sub Panels not already declared
      LetterPanel Panel1 = new LetterPanel();  

		// Properties of Main Panel
      JPanel HolderPanel = new JPanel();
      HolderPanel.setPreferredSize(new Dimension(650,285));
      HolderPanel.setBackground (Color.black);
		MainWindow.setResizable(false);

		// Add SubPanels
      HolderPanel.add(Panel1);
      HolderPanel.add(Panel2);
      HolderPanel.add(Panel3);

		// Prepare Primary Frame
      MainWindow.getContentPane().add(HolderPanel);
      MainWindow.pack(); 
		
		// Setup Frame to handle "Word Selection Wait Message Box"
		JFrame WaitWindow = new JFrame("Please Wait...");
		WaitWindow.setDefaultCloseOperation (JFrame.DO_NOTHING_ON_CLOSE);

		// Properties of "Word Selection Wait Message Box"
		WaitWindow.setResizable(false);
		
		// Setup Panel for "Word Selection Wait Message Box"
      WaitPanel tempPanel = new WaitPanel();
		
		// Prepare "Word Selection Wait Message Box" Frame
      WaitWindow.getContentPane().add(tempPanel);
      WaitWindow.pack();
		
		// BEGIN THE GAME

		// Display Main Window
		MainWindow.setVisible(true);
		
      // Select and Set Random Word, while displaying
		// "Word Selection Wait Message Box" Frame
		WaitWindow.setVisible(true);
      Word word = new Word();
      word.chooseWord();
      gameAnswer = word.getWord();

		// Hide "Word Selection Wait Message Box" Frame
		WaitWindow.setVisible(false);
      
		// Pass Puzzle Object the answer
		puzzle.setAnswer(gameAnswer);

		// Update Status Panel
		Panel3.setPuzzle(puzzle.puzzleToString());
		Panel3.setGuessedLetters(puzzle.guessedToString());		
   }
	
	public static void ButtonEvent(String letter)
	{
		boolean won = false;
		// Add Guessed Letter to List
		puzzle.addLetter(letter);
		
		// Update Picture Panel
		Panel2.clearPanel();
		Panel2.drawPictureInPanel(puzzle.numIncorrectGuesses() + 1);
			
		// Update Status Panel
		Panel3.setPuzzle(puzzle.puzzleToString());
		Panel3.setGuessedLetters(puzzle.guessedToString());	
		
		// Check for Win / Loose
		if(puzzle.numCorrect() == puzzle.length())
      {
			gameOver = true;
			won = true;
		}
      if(puzzle.numIncorrectGuesses() == LOSEVALUE)
      {
			gameOver = true;
			won = false;
		}
				
		// Finish Game if Over
		if(gameOver)
		{
			if(won)
				// Message Box - Won
				JOptionPane.showMessageDialog(MainWindow, "Congratulations!  You Won!  Thanks for playing.\n" + "Correct word was: " + gameAnswer);
			else
				// Message Box - Lost
				JOptionPane.showMessageDialog(MainWindow, "Sorry, you lost.  Better luck next time.\n" + "Correct word was: " + gameAnswer);
			
			// Terminate Java Subsystem on Game End.
			System.exit(0);
		}
	}
}