/*
// Casey Burkhardt
// CSC 1051-002 - Algorithms and Data Structures I
// 12/06/2007
// Puzzle.java
// Manages methods related to operation of the Hangman game puzzle structure
*/

public class Puzzle
{  
   String answer;
   String[] usedList;
   int currentIndex;
   final int USEDLISTSIZE = 30;
   
   // Constructor
   public Puzzle(String currentWord)
   {
      answer = currentWord;
      usedList = new String[USEDLISTSIZE];
      currentIndex = 0;
   }
	
	public Puzzle()
   {
      answer = null;
      usedList = new String[USEDLISTSIZE];
      currentIndex = 0;
   }
	
	// SetWord for GUI
	public void setAnswer(String inputAnswer)
	{
		answer = inputAnswer;
	}
   
   // Return Length of Answer
   public int length()
   {
      return answer.length();
   }
   
   // Return number of characters in the puzzle guessed correctly
   public int numCorrect()
   {
      int value = 0;
      for (int i = 0; i < answer.length(); i++)
      {
         if(onList(Character.toString(answer.charAt(i))) == true)
            value++;
      }
      return value;
   }
   
   // Return number of correct guesses
   public int numCorrectGuesses()
   {
      int value = 0;
      for (int i = 0; i < currentIndex; i++)
      {
         String currentLetter = usedList[i];
         for (int j = 0; j < answer.length(); j++)
         {
            String compareLetter = Character.toString(answer.charAt(j));
            if(currentLetter.equals(compareLetter))
            {
               value++;
               break;
            }
         }
      }
      return value;
   }
   
   // Return number of incorrect guesses
   public int numIncorrectGuesses()
   {
      return currentIndex - numCorrectGuesses();
   }

   // Adds a letter to the used letter list and increments counter
   public void addLetter(String letter)
   {
      usedList[currentIndex] = letter;
      currentIndex = currentIndex + 1;
   }
   
   // Returns boolean based on letter's existance on used list
   public boolean onList(String letter)
   {
      boolean onList = false;
      for(int i = 0; i < currentIndex; i++)
      {
         if(usedList[i].equals(letter) == true)
            onList = true;
      }
      return onList;
   }
   
   // Parse Guessed Letters List
   public String guessedToString()
   {
      String output = "Letters Guessed: ";
      for(int i = 0; i < currentIndex; i++)
      {
         output = output + usedList[i] + " ";
      }
      return output;
   }

   // Parse Puzzle with _'s for Letters Not Guessed
   public String puzzleToString()
   {
      String output = "Puzzle: ";
      for (int i = 0; i < answer.length(); i++)
      {
         if(onList(Character.toString(answer.charAt(i))) == true)
            output = output + Character.toString(answer.charAt(i)) + " ";
         else
            output = output + "_ ";
      }
      return output;
   }
}