/*
// Casey Burkhardt
// CSC 1051-002 - Algorithms and Data Structures I
// 12/06/2007
// Word.java
// Manages a work library for the hangman game.
*/
import java.util.Scanner;
import java.io.*;

public class Word
{  
   File wordList;
   Scanner wordInput;
   String[] wordArray;
   String currentWord;
     
   public Word() throws IOException
   {
      // Setup File Scanner
      wordList = new File("Words.in");
      wordInput = new Scanner(wordList);
      
      // Declare Initial Array
      wordArray = new String[1];
      
      // Read Dictionary File to Array
      for(int i = 0; wordInput.hasNext(); i++)
      {
         wordArray[i] = wordInput.nextLine();
         
         // Double Array Size if Necessary
         if((wordArray.length - 1) == i)
         {
            String[] tempArray = new String[(wordArray.length * 2)];
            for(int j = 0; j < wordArray.length; j++)
            {
               tempArray[j] = wordArray[j];
            }
            wordArray = tempArray;
         }
      }
      
      // Setup Instance Variable to Hold Current Game Word
      currentWord = "No Word Selected";
   }
   
   public void chooseWord()
   {
      // Pick Random Word and Assign to Current Game Word Instance Variable
      int randomIndex = (int)(Math.random() * wordArray.length);
      currentWord = wordArray[randomIndex];
      
      // Use recursion to fix null selection bug.
      if(currentWord == null)
         chooseWord();
   }
   
   public String getWord()
   {
      // Returns Current Game Word
      return currentWord.toUpperCase();
   }
}